Commit d3363964 authored by Eduardo San Martin Morote's avatar Eduardo San Martin Morote
Browse files

Updated z version

Closes #3248
Closes #4570
parent e44aa503
...@@ -6,7 +6,7 @@ NAME ...@@ -6,7 +6,7 @@ NAME
z - jump around z - jump around
SYNOPSIS SYNOPSIS
z [-chlrt] [regex1 regex2 ... regexn] z [-chlrtx] [regex1 regex2 ... regexn]
AVAILABILITY AVAILABILITY
bash, zsh bash, zsh
...@@ -15,10 +15,13 @@ DESCRIPTION ...@@ -15,10 +15,13 @@ DESCRIPTION
Tracks your most used directories, based on 'frecency'. Tracks your most used directories, based on 'frecency'.
After a short learning phase, z will take you to the most 'frecent' After a short learning phase, z will take you to the most 'frecent'
directory that matches ALL of the regexes given on the command line. directory that matches ALL of the regexes given on the command line, in
order.
For example, z foo bar would match /foo/bar but not /bar/foo.
OPTIONS OPTIONS
-c restrict matches to subdirectories of the current directory. -c restrict matches to subdirectories of the current directory
-h show a brief help message -h show a brief help message
...@@ -28,10 +31,12 @@ OPTIONS ...@@ -28,10 +31,12 @@ OPTIONS
-t match by recent access only -t match by recent access only
-x remove the current directory from the datafile
EXAMPLES EXAMPLES
z foo cd to most frecent dir matching foo z foo cd to most frecent dir matching foo
z foo bar cd to most frecent dir matching foo and bar z foo bar cd to most frecent dir matching foo, then bar
z -r foo cd to highest ranked dir matching foo z -r foo cd to highest ranked dir matching foo
...@@ -55,8 +60,9 @@ NOTES ...@@ -55,8 +60,9 @@ NOTES
Set $_Z_NO_RESOLVE_SYMLINKS to prevent symlink resolution. Set $_Z_NO_RESOLVE_SYMLINKS to prevent symlink resolution.
Set $_Z_NO_PROMPT_COMMAND to handle PROMPT_COMMAND/precmd your- Set $_Z_NO_PROMPT_COMMAND to handle PROMPT_COMMAND/precmd your-
self. self.
Set $_Z_EXCLUDE_DIRS to an array of directories to exclude. Set $_Z_EXCLUDE_DIRS to an array of directory trees to exclude.
(These settings should go in .bashrc/.zshrc before the lines Set $_Z_OWNER to allow usage when in 'sudo -s' mode.
(These settings should go in .bashrc/.zshrc before the line
added above.) added above.)
Install the provided man page z.1 somewhere like Install the provided man page z.1 somewhere like
/usr/local/man/man1. /usr/local/man/man1.
...@@ -64,12 +70,12 @@ NOTES ...@@ -64,12 +70,12 @@ NOTES
Aging: Aging:
The rank of directories maintained by z undergoes aging based on a sim- The rank of directories maintained by z undergoes aging based on a sim-
ple formula. The rank of each entry is incremented every time it is ple formula. The rank of each entry is incremented every time it is
accessed. When the sum of ranks is greater than 6000, all ranks are accessed. When the sum of ranks is over 9000, all ranks are multiplied
multiplied by 0.99. Entries with a rank lower than 1 are forgotten. by 0.99. Entries with a rank lower than 1 are forgotten.
Frecency: Frecency:
Frecency is a portmantaeu of 'recent' and 'frequency'. It is a weighted Frecency is a portmanteau of 'recent' and 'frequency'. It is a weighted
rank that depends on how often and how recently something occured. As rank that depends on how often and how recently something occurred. As
far as I know, Mozilla came up with the term. far as I know, Mozilla came up with the term.
To z, a directory that has low ranking but has been accessed recently To z, a directory that has low ranking but has been accessed recently
...@@ -107,20 +113,23 @@ ENVIRONMENT ...@@ -107,20 +113,23 @@ ENVIRONMENT
resolving of symlinks. If it is not set, symbolic links will be resolving of symlinks. If it is not set, symbolic links will be
resolved when added to the datafile. resolved when added to the datafile.
In bash, z prepends a command to the PROMPT_COMMAND environment vari- In bash, z appends a command to the PROMPT_COMMAND environment variable
able to maintain its database. In zsh, z appends a function _z_precmd to maintain its database. In zsh, z appends a function _z_precmd to the
to the precmd_functions array. precmd_functions array.
The environment variable $_Z_NO_PROMPT_COMMAND can be set if you want The environment variable $_Z_NO_PROMPT_COMMAND can be set if you want
to handle PROMPT_COMMAND or precmd yourself. to handle PROMPT_COMMAND or precmd yourself.
The environment variable $_Z_EXCLUDE_DIRS can be set to an array of The environment variable $_Z_EXCLUDE_DIRS can be set to an array of
directories to exclude from tracking. $HOME is always excluded. Direc- directory trees to exclude from tracking. $HOME is always excluded.
tories must be full paths without trailing slashes. Directories must be full paths without trailing slashes.
The environment variable $_Z_OWNER can be set to your username, to
allow usage of z when your sudo enviroment keeps $HOME set.
FILES FILES
Data is stored in $HOME/.z. This can be overridden by setting the Data is stored in $HOME/.z. This can be overridden by setting the
$_Z_DATA environment variable. When initialized, z will raise an error $_Z_DATA environment variable. When initialized, z will raise an error
if this path is a directory, and not function correctly. if this path is a directory, and not function correctly.
A man page (z.1) is provided. A man page (z.1) is provided.
......
...@@ -4,7 +4,7 @@ NAME ...@@ -4,7 +4,7 @@ NAME
z \- jump around z \- jump around
.SH .SH
SYNOPSIS SYNOPSIS
z [\-chlrt] [regex1 regex2 ... regexn] z [\-chlrtx] [regex1 regex2 ... regexn]
.SH .SH
AVAILABILITY AVAILABILITY
bash, zsh bash, zsh
...@@ -13,12 +13,14 @@ DESCRIPTION ...@@ -13,12 +13,14 @@ DESCRIPTION
Tracks your most used directories, based on 'frecency'. Tracks your most used directories, based on 'frecency'.
.P .P
After a short learning phase, \fBz\fR will take you to the most 'frecent' After a short learning phase, \fBz\fR will take you to the most 'frecent'
directory that matches ALL of the regexes given on the command line. directory that matches ALL of the regexes given on the command line, in order.
For example, \fBz foo bar\fR would match \fB/foo/bar\fR but not \fB/bar/foo\fR.
.SH .SH
OPTIONS OPTIONS
.TP .TP
\fB\-c\fR \fB\-c\fR
restrict matches to subdirectories of the current directory. restrict matches to subdirectories of the current directory
.TP .TP
\fB\-h\fR \fB\-h\fR
show a brief help message show a brief help message
...@@ -31,13 +33,16 @@ match by rank only ...@@ -31,13 +33,16 @@ match by rank only
.TP .TP
\fB\-t\fR \fB\-t\fR
match by recent access only match by recent access only
.TP
\fB\-x\fR
remove the current directory from the datafile
.SH EXAMPLES .SH EXAMPLES
.TP 14 .TP 14
\fBz foo\fR \fBz foo\fR
cd to most frecent dir matching foo cd to most frecent dir matching foo
.TP 14 .TP 14
\fBz foo bar\fR \fBz foo bar\fR
cd to most frecent dir matching foo and bar cd to most frecent dir matching foo, then bar
.TP 14 .TP 14
\fBz -r foo\fR \fBz -r foo\fR
cd to highest ranked dir matching foo cd to highest ranked dir matching foo
...@@ -76,10 +81,13 @@ Set \fB$_Z_NO_RESOLVE_SYMLINKS\fR to prevent symlink resolution. ...@@ -76,10 +81,13 @@ Set \fB$_Z_NO_RESOLVE_SYMLINKS\fR to prevent symlink resolution.
Set \fB$_Z_NO_PROMPT_COMMAND\fR to handle \fBPROMPT_COMMAND/precmd\fR yourself. Set \fB$_Z_NO_PROMPT_COMMAND\fR to handle \fBPROMPT_COMMAND/precmd\fR yourself.
.RE .RE
.RS .RS
Set \fB$_Z_EXCLUDE_DIRS\fR to an array of directories to exclude. Set \fB$_Z_EXCLUDE_DIRS\fR to an array of directory trees to exclude.
.RE
.RS
Set \fB$_Z_OWNER\fR to allow usage when in 'sudo -s' mode.
.RE .RE
.RS .RS
(These settings should go in .bashrc/.zshrc before the lines added above.) (These settings should go in .bashrc/.zshrc before the line added above.)
.RE .RE
.RS .RS
Install the provided man page \fBz.1\fR somewhere like \fB/usr/local/man/man1\fR. Install the provided man page \fBz.1\fR somewhere like \fB/usr/local/man/man1\fR.
...@@ -88,12 +96,12 @@ Install the provided man page \fBz.1\fR somewhere like \fB/usr/local/man/man1\fR ...@@ -88,12 +96,12 @@ Install the provided man page \fBz.1\fR somewhere like \fB/usr/local/man/man1\fR
Aging: Aging:
The rank of directories maintained by \fBz\fR undergoes aging based on a simple The rank of directories maintained by \fBz\fR undergoes aging based on a simple
formula. The rank of each entry is incremented every time it is accessed. When formula. The rank of each entry is incremented every time it is accessed. When
the sum of ranks is greater than 6000, all ranks are multiplied by 0.99. Entries the sum of ranks is over 9000, all ranks are multiplied by 0.99. Entries with a
with a rank lower than 1 are forgotten. rank lower than 1 are forgotten.
.SS .SS
Frecency: Frecency:
Frecency is a portmantaeu of 'recent' and 'frequency'. It is a weighted rank Frecency is a portmanteau of 'recent' and 'frequency'. It is a weighted rank
that depends on how often and how recently something occured. As far as I that depends on how often and how recently something occurred. As far as I
know, Mozilla came up with the term. know, Mozilla came up with the term.
.P .P
To \fBz\fR, a directory that has low ranking but has been accessed recently To \fBz\fR, a directory that has low ranking but has been accessed recently
...@@ -131,7 +139,7 @@ The environment variable \fB$_Z_NO_RESOLVE_SYMLINKS\fR can be set to prevent ...@@ -131,7 +139,7 @@ The environment variable \fB$_Z_NO_RESOLVE_SYMLINKS\fR can be set to prevent
resolving of symlinks. If it is not set, symbolic links will be resolved when resolving of symlinks. If it is not set, symbolic links will be resolved when
added to the datafile. added to the datafile.
.P .P
In bash, \fBz\fR prepends a command to the \fBPROMPT_COMMAND\fR environment In bash, \fBz\fR appends a command to the \fBPROMPT_COMMAND\fR environment
variable to maintain its database. In zsh, \fBz\fR appends a function variable to maintain its database. In zsh, \fBz\fR appends a function
\fB_z_precmd\fR to the \fBprecmd_functions\fR array. \fB_z_precmd\fR to the \fBprecmd_functions\fR array.
.P .P
...@@ -139,8 +147,11 @@ The environment variable \fB$_Z_NO_PROMPT_COMMAND\fR can be set if you want to ...@@ -139,8 +147,11 @@ The environment variable \fB$_Z_NO_PROMPT_COMMAND\fR can be set if you want to
handle \fBPROMPT_COMMAND\fR or \fBprecmd\fR yourself. handle \fBPROMPT_COMMAND\fR or \fBprecmd\fR yourself.
.P .P
The environment variable \fB$_Z_EXCLUDE_DIRS\fR can be set to an array of The environment variable \fB$_Z_EXCLUDE_DIRS\fR can be set to an array of
directories to exclude from tracking. \fB$HOME\fR is always excluded. directory trees to exclude from tracking. \fB$HOME\fR is always excluded.
Directories must be full paths without trailing slashes. Directories must be full paths without trailing slashes.
.P
The environment variable \fB$_Z_OWNER\fR can be set to your username, to
allow usage of \fBz\fR when your sudo enviroment keeps \fB$HOME\fR set.
.SH .SH
FILES FILES
Data is stored in \fB$HOME/.z\fR. This can be overridden by setting the Data is stored in \fB$HOME/.z\fR. This can be overridden by setting the
......
...@@ -3,29 +3,25 @@ ...@@ -3,29 +3,25 @@
# maintains a jump-list of the directories you actually use # maintains a jump-list of the directories you actually use
# #
# INSTALL: # INSTALL:
# * put something like this in your .bashrc/.zshrc: # * put something like this in your .bashrc/.zshrc:
# . /path/to/z.sh # . /path/to/z.sh
# * cd around for a while to build up the db # * cd around for a while to build up the db
# * PROFIT!! # * PROFIT!!
# * optionally: # * optionally:
# set $_Z_CMD in .bashrc/.zshrc to change the command (default z). # set $_Z_CMD in .bashrc/.zshrc to change the command (default z).
# set $_Z_DATA in .bashrc/.zshrc to change the datafile (default ~/.z). # set $_Z_DATA in .bashrc/.zshrc to change the datafile (default ~/.z).
# set $_Z_NO_RESOLVE_SYMLINKS to prevent symlink resolution. # set $_Z_NO_RESOLVE_SYMLINKS to prevent symlink resolution.
# set $_Z_NO_PROMPT_COMMAND if you're handling PROMPT_COMMAND yourself. # set $_Z_NO_PROMPT_COMMAND if you're handling PROMPT_COMMAND yourself.
# set $_Z_EXCLUDE_DIRS to an array of directories to exclude. # set $_Z_EXCLUDE_DIRS to an array of directories to exclude.
# set $_Z_OWNER to your username if you want use z while sudo with $HOME kept
# #
# USE: # USE:
# * z foo # cd to most frecent dir matching foo # * z foo # cd to most frecent dir matching foo
# * z foo bar # cd to most frecent dir matching foo and bar # * z foo bar # cd to most frecent dir matching foo and bar
# * z -r foo # cd to highest ranked dir matching foo # * z -r foo # cd to highest ranked dir matching foo
# * z -t foo # cd to most recently accessed dir matching foo # * z -t foo # cd to most recently accessed dir matching foo
# * z -l foo # list matches instead of cd # * z -l foo # list matches instead of cd
# * z -c foo # restrict matches to subdirs of $PWD # * z -c foo # restrict matches to subdirs of $PWD
case $- in
*i*) ;;
*) echo 'ERROR: z.sh is meant to be sourced, not directly executed.'
esac
[ -d "${_Z_DATA:-$HOME/.z}" ] && { [ -d "${_Z_DATA:-$HOME/.z}" ] && {
echo "ERROR: z.sh's datafile (${_Z_DATA:-$HOME/.z}) is a directory." echo "ERROR: z.sh's datafile (${_Z_DATA:-$HOME/.z}) is a directory."
...@@ -33,196 +29,215 @@ esac ...@@ -33,196 +29,215 @@ esac
_z() { _z() {
local datafile="${_Z_DATA:-$HOME/.z}" local datafile="${_Z_DATA:-$HOME/.z}"
# bail out if we don't own ~/.z (we're another user but our ENV is still set) # bail if we don't own ~/.z and $_Z_OWNER not set
[ -f "$datafile" -a ! -O "$datafile" ] && return [ -z "$_Z_OWNER" -a -f "$datafile" -a ! -O "$datafile" ] && return
# add entries # add entries
if [ "$1" = "--add" ]; then if [ "$1" = "--add" ]; then
shift shift
# $HOME isn't worth matching # $HOME isn't worth matching
[ "$*" = "$HOME" ] && return [ "$*" = "$HOME" ] && return
# don't track excluded dirs # don't track excluded directory trees
local exclude local exclude
for exclude in "${_Z_EXCLUDE_DIRS[@]}"; do for exclude in "${_Z_EXCLUDE_DIRS[@]}"; do
[ "$*" = "$exclude" ] && return case "$*" in "$exclude*") return;; esac
done done
# maintain the file # maintain the data file
local tempfile local tempfile="$datafile.$RANDOM"
tempfile="$(mktemp "$datafile.XXXXXX")" || return while read line; do
while read line; do # only count directories
[ -d "${line%%\|*}" ] && echo $line [ -d "${line%%\|*}" ] && echo $line
done < "$datafile" | awk -v path="$*" -v now="$(date +%s)" -F"|" ' done < "$datafile" | awk -v path="$*" -v now="$(date +%s)" -F"|" '
BEGIN { BEGIN {
rank[path] = 1 rank[path] = 1
time[path] = now time[path] = now
} }
$2 >= 1 { $2 >= 1 {
if( $1 == path ) { # drop ranks below 1
rank[$1] = $2 + 1 if( $1 == path ) {
time[$1] = now rank[$1] = $2 + 1
} else { time[$1] = now
rank[$1] = $2 } else {
time[$1] = $3 rank[$1] = $2
} time[$1] = $3
count += $2 }
} count += $2
END { }
if( count > 6000 ) { END {
for( i in rank ) print i "|" 0.99*rank[i] "|" time[i] # aging if( count > 9000 ) {
} else for( i in rank ) print i "|" rank[i] "|" time[i] # aging
} for( x in rank ) print x "|" 0.99*rank[x] "|" time[x]
' 2>/dev/null >| "$tempfile" } else for( x in rank ) print x "|" rank[x] "|" time[x]
if [ $? -ne 0 -a -f "$datafile" ]; then }
env rm -f "$tempfile" ' 2>/dev/null >| "$tempfile"
else # do our best to avoid clobbering the datafile in a race condition
env mv -f "$tempfile" "$datafile" if [ $? -ne 0 -a -f "$datafile" ]; then
fi env rm -f "$tempfile"
else
# tab completion [ "$_Z_OWNER" ] && chown $_Z_OWNER:$(id -ng $_Z_OWNER) "$tempfile"
elif [ "$1" = "--complete" ]; then env mv -f "$tempfile" "$datafile" || env rm -f "$tempfile"
while read line; do fi
[ -d "${line%%\|*}" ] && echo $line
done < "$datafile" | awk -v q="$2" -F"|" ' # tab completion
BEGIN { elif [ "$1" = "--complete" -a -s "$datafile" ]; then
if( q == tolower(q) ) nocase = 1 while read line; do
split(substr(q,3),fnd," ") [ -d "${line%%\|*}" ] && echo $line
} done < "$datafile" | awk -v q="$2" -F"|" '
{ BEGIN {
if( nocase ) { if( q == tolower(q) ) imatch = 1
for( i in fnd ) tolower($1) !~ tolower(fnd[i]) && $1 = "" q = substr(q, 3)
} else { gsub(" ", ".*", q)
for( i in fnd ) $1 !~ fnd[i] && $1 = "" }
} {
if( $1 ) print $1 if( imatch ) {
} if( tolower($1) ~ tolower(q) ) print $1
' 2>/dev/null } else if( $1 ~ q ) print $1
}
else ' 2>/dev/null
# list/go
while [ "$1" ]; do case "$1" in else
--) while [ "$1" ]; do shift; local fnd="$fnd $1";done;; # list/go
-*) local opt=${1:1}; while [ "$opt" ]; do case ${opt:0:1} in while [ "$1" ]; do case "$1" in
c) local fnd="^$PWD $fnd";; --) while [ "$1" ]; do shift; local fnd="$fnd${fnd:+ }$1";done;;
h) echo "${_Z_CMD:-z} [-chlrt] args" >&2; return;; -*) local opt=${1:1}; while [ "$opt" ]; do case ${opt:0:1} in
l) local list=1;; c) local fnd="^$PWD $fnd";;
r) local typ="rank";; h) echo "${_Z_CMD:-z} [-chlrtx] args" >&2; return;;
t) local typ="recent";; x) sed -i -e "\:^${PWD}|.*:d" "$datafile";;
esac; opt=${opt:1}; done;; l) local list=1;;
*) local fnd="$fnd $1";; r) local typ="rank";;
esac; local last=$1; shift; done t) local typ="recent";;
[ "$fnd" -a "$fnd" != "^$PWD " ] || local list=1 esac; opt=${opt:1}; done;;
*) local fnd="$fnd${fnd:+ }$1";;
# if we hit enter on a completion just go there esac; local last=$1; [ "$#" -gt 0 ] && shift; done
case "$last" in [ "$fnd" -a "$fnd" != "^$PWD " ] || local list=1
# completions will always start with /
/*) [ -z "$list" -a -d "$last" ] && cd "$last" && return;; # if we hit enter on a completion just go there
esac case "$last" in
# completions will always start with /
# no file yet /*) [ -z "$list" -a -d "$last" ] && cd "$last" && return;;
[ -f "$datafile" ] || return esac
local cd # no file yet
cd="$(while read line; do [ -f "$datafile" ] || return
[ -d "${line%%\|*}" ] && echo $line
done < "$datafile" | awk -v t="$(date +%s)" -v list="$list" -v typ="$typ" -v q="$fnd" -F"|" ' local cd
function frecent(rank, time) { cd="$(while read line; do
dx = t-time [ -d "${line%%\|*}" ] && echo $line
if( dx < 3600 ) return rank*4 done < "$datafile" | awk -v t="$(date +%s)" -v list="$list" -v typ="$typ" -v q="$fnd" -F"|" '
if( dx < 86400 ) return rank*2 function frecent(rank, time) {
if( dx < 604800 ) return rank/2 # relate frequency and time
return rank/4 dx = t - time
} if( dx < 3600 ) return rank * 4
function output(files, toopen, override) { if( dx < 86400 ) return rank * 2
if( list ) { if( dx < 604800 ) return rank / 2
cmd = "sort -n >&2" return rank / 4
for( i in files ) if( files[i] ) printf "%-10s %s\n", files[i], i | cmd }
if( override ) printf "%-10s %s\n", "common:", override > "/dev/stderr" function output(files, out, common) {
} else { # list or return the desired directory
if( override ) toopen = override if( list ) {
print toopen cmd = "sort -n >&2"
} for( x in files ) {
} if( files[x] ) printf "%-10s %s\n", files[x], x | cmd
function common(matches) { }
# shortest match if( common ) {
for( i in matches ) { printf "%-10s %s\n", "common:", common > "/dev/stderr"
if( matches[i] && (!short || length(i) < length(short)) ) short = i }
} } else {
if( short == "/" ) return if( common ) out = common
# shortest match must be common to each match. escape special characters in print out
# a copy when testing, so we can return the original. }
clean_short = short }
gsub(/[\(\)\[\]\|]/, "\\\\&", clean_short) function common(matches) {
for( i in matches ) if( matches[i] && i !~ clean_short ) return # find the common root of a list of matches, if it exists
return short for( x in matches ) {
} if( matches[x] && (!short || length(x) < length(short)) ) {
BEGIN { split(q, a, " "); oldf = noldf = -9999999999 } short = x
{ }
if( typ == "rank" ) { }
f = $2 if( short == "/" ) return
} else if( typ == "recent" ) { # use a copy to escape special characters, as we want to return
f = $3-t # the original. yeah, this escaping is awful.
} else f = frecent($2, $3) clean_short = short
wcase[$1] = nocase[$1] = f gsub(/\[\(\)\[\]\|\]/, "\\\\&", clean_short)
for( i in a ) { for( x in matches ) if( matches[x] && x !~ clean_short ) return
if( $1 !~ a[i] ) delete wcase[$1] return short
if( tolower($1) !~ tolower(a[i]) ) delete nocase[$1] }
} BEGIN {
if( wcase[$1] && wcase[$1] > oldf ) { gsub(" ", ".*", q)
cx = $1 hi_rank = ihi_rank = -9999999999
oldf = wcase[$1] }
} else if( nocase[$1] && nocase[$1] > noldf ) { {
ncx = $1 if( typ == "rank" ) {
noldf = nocase[$1] rank = $2
} } else if( typ == "recent" ) {
} rank = $3 - t
END { } else rank = frecent($2, $3)
if( cx ) { if( $1 ~ q ) {
output(wcase, cx, common(wcase)) matches[$1] = rank
} else if( ncx ) output(nocase, ncx, common(nocase)) } else if( tolower($1) ~ tolower(q) ) imatches[$1] = rank
} if( matches[$1] && matches[$1] > hi_rank ) {
')" best_match = $1
[ $? -gt 0 ] && return hi_rank = matches[$1]
[ "$cd" ] && cd "$cd" } else if( imatches[$1] && imatches[$1] > ihi_rank ) {
fi ibest_match = $1
ihi_rank = imatches[$1]
}
}
END {
# prefer case sensitive
if( best_match ) {
output(matches, best_match, common(matches))
} else if( ibest_match ) {
output(imatches, ibest_match, common(imatches))
}
}
')"
[ $? -gt 0 ] && return
[ "$cd" ] && cd "$cd"
fi
} }
alias ${_Z_CMD:-z}='_z 2>&1' alias ${_Z_CMD:-z}='_z 2>&1'
[ "$_Z_NO_RESOLVE_SYMLINKS" ] || _Z_RESOLVE_SYMLINKS="-P" [ "$_Z_NO_RESOLVE_SYMLINKS" ] || _Z_RESOLVE_SYMLINKS="-P"
if compctl &> /dev/null; then if type compctl >/dev/null 2>&1; then
[ "$_Z_NO_PROMPT_COMMAND" ] || { # zsh
# zsh populate directory list, avoid clobbering any other precmds [ "$_Z_NO_PROMPT_COMMAND" ] || {
if [ "$_Z_NO_RESOLVE_SYMLINKS" ]; then # populate directory list, avoid clobbering any other precmds.
_z_precmd() { if [ "$_Z_NO_RESOLVE_SYMLINKS" ]; then
_z --add "${PWD:a}" _z_precmd() {
_z --add "${PWD:a}"
}
else
_z_precmd() {
_z --add "${PWD:A}"
}
fi
[[ -n "${precmd_functions[(r)_z_precmd]}" ]] || {
precmd_functions[$(($#precmd_functions+1))]=_z_precmd
}
}
_z_zsh_tab_completion() {
# tab completion
local compl
read -l compl
reply=(${(f)"$(_z --complete "$compl")"})
} }
else compctl -U -K _z_zsh_tab_completion _z
_z_precmd() { elif type complete >/dev/null 2>&1; then
_z --add "${PWD:A}" # bash
# tab completion
complete -o filenames -C '_z --complete "$COMP_LINE"' ${_Z_CMD:-z}
[ "$_Z_NO_PROMPT_COMMAND" ] || {
# populate directory list. avoid clobbering other PROMPT_COMMANDs.
grep "_z --add" <<< "$PROMPT_COMMAND" >/dev/null || {
PROMPT_COMMAND="$PROMPT_COMMAND"$'\n''_z --add "$(command pwd '$_Z_RESOLVE_SYMLINKS' 2>/dev/null)" 2>/dev/null;'
}
} }
fi
precmd_functions+=(_z_precmd)
}
# zsh tab completion
_z_zsh_tab_completion() {
local compl
read -l compl
reply=(${(f)"$(_z --complete "$compl")"})
}
compctl -U -K _z_zsh_tab_completion _z
elif complete &> /dev/null; then
# bash tab completion
complete -o filenames -C '_z --complete "$COMP_LINE"' ${_Z_CMD:-z}
[ "$_Z_NO_PROMPT_COMMAND" ] || {
# bash populate directory list. avoid clobbering other PROMPT_COMMANDs.
echo $PROMPT_COMMAND | grep -q "_z --add" || {
PROMPT_COMMAND='_z --add "$(pwd '$_Z_RESOLVE_SYMLINKS' 2>/dev/null)" 2>/dev/null;'"$PROMPT_COMMAND"
}
}
fi fi
Markdown is supported
0% or .
You are about to add 0 people to the discussion. Proceed with caution.
Finish editing this message first!
Please register or to comment